﻿using Infragistics.Documents.Excel;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.IO;
using System.Threading.Tasks;
using Xamarin.Forms;
using XF_XAMLAppTemplate.Droid.Models;
using System.Reflection;
using System.Linq;

namespace XF_XAMLAppTemplate
{
    public partial class MainPage : ContentPage
    {
       
        ExcelData _data;
        
        public MainPage()
        {
            InitializeComponent();
           
			ExcelData _data;
					
			var assembly = typeof(MainPage).GetTypeInfo().Assembly;
			Stream stream = assembly.
			GetManifestResourceStream("XFCategoryChart.tst1.xls");
						
			_data = GetExcelData(stream);

			/// (Continued below)

            this.BindingContext = _data;
        }
        
    private ExcelData GetExcelData(Stream fileName)
        {

            
            Workbook workbook1;
            
			using (streamName)
			{
				workbook1 = Workbook.Load(streamName);		
			}

			int columnsNumber = 0;
			string column;
			List<string> gridColumns = new List<string>();
					
				var worksheet = workbook1.Worksheets[0];

				while (worksheet.Rows[0].GetCellValue(columnsNumber) != null)
				{
					columnsNumber++;
				}

				for (var columnIndex = 0; columnIndex < columnsNumber; 
					 columnIndex++)
				{                
					column = worksheet.Rows[0].GetCellText(columnIndex);
					gridColumns.Add(column);
				}

				 var worksheetRowsCount = worksheet.Rows.Count();
			     var items = new ExcelData();

					for (var i = 1; i < worksheetRowsCount; i++)
					{
						var newRow = new Dictionary<string, object>();

						var row = worksheet.Rows[i];

						for (var columnIndex = 0; columnIndex < columnsNumber; columnIndex++)
						{
							var cellValue = row.GetCellText(columnIndex);
							double doubleValue;
							if (double.TryParse(cellValue, out doubleValue))
							{
								newRow[gridColumns[columnIndex]] = doubleValue;
							}
							else
							{
								newRow[gridColumns[columnIndex]] = cellValue;
							}
						}

						items.Add(newRow);
					}

					return items;

						}
    }
	  
	public class ExcelData : ObservableCollection<Dictionary<string, object>>
	{
		public void NotifyReset()
		{
			OnCollectionChanged(new System.Collections.Specialized.
			NotifyCollectionChangedEventArgs(System.Collections.
			Specialized.NotifyCollectionChangedAction.Reset));
		}
	}


    }

}
